// SM64 level import in assembly
// use armips on 64MB extended and obj import, music, collision patched ROM

.n64
.open "sm64.3.collision.z64", "sm64.4.level_import.z64", 0x80245000

// -----------------------------------------------------------------------------
// Existing functions
// -----------------------------------------------------------------------------
.org 0x80278504
DmaCopy:
.org 0x8027868C
DynamicIndexCopy:

// -----------------------------------------------------------------------------
// replace JALs in Geo18_802D104C
// -----------------------------------------------------------------------------
.org 0x802D11AC
jal Func80403000 // 08C1AC 802D11AC 0C0B4321  jal   proc_802D0C84
.org 0x802D11E8
jal Func80403500 // 08C1E8 802D11E8 0C0B43CA  jal   proc_802D0F28

.headersize 0x80283280

// -----------------------------------------------------------------------------
// update ROM offsets for DMA of expansion RAM code
// -----------------------------------------------------------------------------
.org 0x80384E28
lui   a0, 0x8040     // 101BA8 80384E28 lui   a0, 0x8040
ori   a0, a0, 0x2000 // 101BAC 80384E2C ori   a0, a0, 0
lui   a1, 0x120      // 101BB0 80384E30 lui   a1, 0x120
ori   a1, a1, 0x2000 // 101BB4 80384E34 ori   a1, a1, 0
lui   a2, 0x121      // 101BB8 80384E38 lui   a2, 0x130

// -----------------------------------------------------------------------------
// replace level script 0x10 function pointer
// -----------------------------------------------------------------------------
.orga 0x108678
.dw ExtLevelScript10

.headersize 0x7F200000
// -----------------------------------------------------------------------------
// new functions in expansion RAM
// -----------------------------------------------------------------------------
.org 0x80402000
ExtLevelScript10:
  addiu sp, sp, -0x30
  sw    ra, 0x2c(sp)
  sw    fp, 0x28(sp)
  move  fp, sp
  lui   gp, 0x8040
  addiu gp, gp, 0x2270
  lui   v0, 0x8038
  ori   v0, v0, 0xbe28
  sw    v0, 0x18(fp)
  lui   v0, 0x8038
  ori   v0, v0, 0xbe28
  sw    v0, 0x14(fp)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v1, 2(v0)
  addiu v0, zero, 1
  bne   v1, v0, L804021C8
  nop
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v0, 3(v0)
  sll   v0, v0, 2
  move  v1, v0
  lui   v0, 0x8033
  ori   v0, v0, 0xb400
  addu  v0, v1, v0
  sw    v0, 0x10(fp)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v0, 3(v0)
  addiu v0, v0, -5
  sw    v0, 0x20(fp)
  lw    v1, 0x20(fp)
  sltiu v0, v1, 0xf
  beqz  v0, L80402200
  nop
  lw    v0, 0x20(fp)
  sll   v1, v0, 2
  lui   v0, 0x8040
  addiu v0, v0, 0x2234
  addu  v0, v1, v0
  lw    v0, (v0)
  jr    v0
  nop
L804020B0:
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  lui   a0, 0x8042
  move  a1, v1
  jal   DmaCopy // 0x278504
  move  a2, v0
  lw    v1, 0x10(fp)
  lui   v0, 0x42
  j     L80402200
  sw    v0, (v1)
L804020E8:
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  lui   a0, 0x8062
  move  a1, v1
  jal   DmaCopy // 0x278504
  move  a2, v0
  lw    v1, 0x10(fp)
  lui   v0, 0x62
  j     L80402200
  sw    v0, (v1)
L80402120:
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  lui   a0, 0x8057
  move  a1, v1
  jal   DmaCopy // 0x278504
  move  a2, v0
  lw    v1, 0x10(fp)
  lui   v0, 0x57
  j     L80402200
  sw    v0, (v1)
L80402158:
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  lui   a0, 0x8072
  move  a1, v1
  jal   DmaCopy // 0x278504
  move  a2, v0
  lw    v1, 0x10(fp)
  lui   v0, 0x72
  j     L80402200
  sw    v0, (v1)
L80402190:
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  lui   a0, 0x807b
  move  a1, v1
  jal   DmaCopy // 0x278504
  move  a2, v0
  lw    v1, 0x10(fp)
  lui   v0, 0x7b
  j     L80402200
  sw    v0, (v1)
L804021C8:
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v0, 3(v0)
  move  a0, v0
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  move  a1, v1
  move  a2, v0
  jal   DynamicIndexCopy // 0x27868c
  move  a3, zero
L80402200:
  lw    v0, 0x14(fp)
  lw    v1, (v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v0, 1(v0)
  addu  v1, v1, v0
  lw    v0, 0x14(fp)
  sw    v1, (v0)
  move  sp, fp
  lw    ra, 0x2c(sp)
  lw    fp, 0x28(sp)
  jr    ra
  addiu sp, sp, 0x30
jmptbl80402000:
.dw L80402158, L80402120, L804020E8, L80402200
.dw L80402200, L80402200, L80402200, L80402200
.dw L80402200, L804020B0, L80402200, L80402200
.dw L80402200, L80402200, L80402190

// -----------------------------------------------------------------------------
// TODO: what is this data?
// -----------------------------------------------------------------------------
.org 0x80402300
.dw 0x00040000, 0x11012041, 0x08000000, 0x0C000000
.dw Func80402400, 0x09000000

// -----------------------------------------------------------------------------
// TODO: what is this function?
// -----------------------------------------------------------------------------
.org 0x80402400
Func80402400:
  addiu sp, sp, -0x18
  sw    ra, 0x14(sp)
  lui   t0, 0x8036
  lw    t0, 0x1160(t0)
  lui   a0, 0x8040
  lb    t1, 0x21(t0)
  sll   t1, t1, 0x10
  addu  a0, a0, t1
  lh    t1, 0x188(t0)
  andi  t1, t1, 0xffff
  addu  a0, a0, t1
  lb    t1, 0x25(t0)
  andi  t1, t1, 0xff
  add   a1, t1, t1
  add   a1, a1, t1
  lb    a2, 0x29(t0)
  ori   t8, zero, 0
  ori   a3, zero, 0
  addi  t9, zero, 0x1000
// TODO: what is this instruction?
.dw 0x0326C81A
  mflo  t9
@@L80402454:
  addi  t8, t8, 1
  bne   t8, a2, @@L80402454
  add   a3, a3, t9
  lh    s0, 0x40(t0)
  slt   s1, s0, t9
  bnez  s1, @@L80402474
  addiu s0, s0, 1
  addiu s0, zero, 1
@@L80402474:
  sh    s0, 0x40(t0)
@@L80402478:
  lh    t2, (a0)
  bnez  s1, @@L80402488
  add   t2, t2, a2
  sub   t2, t2, a3
@@L80402488:
  sh    t2, (a0)
  addi  a1, a1, -1
  bnez  a1, @@L80402478
  addiu a0, a0, 0x10
  lw    ra, 0x14(sp)
  jr    ra
  addiu sp, sp, 0x18

// -----------------------------------------------------------------------------
// replacement functions called from Geo18
// -----------------------------------------------------------------------------
.org 0x80403000
Func80403000:
  addiu sp, sp, -0x20
  sw    fp, 0x1c(sp)
  move  fp, sp
  move  v0, a0
  sh    v0, 0x20(fp)
  lui   gp, 0x8040
  addiu gp, gp, 0x3480
  lhu   v1, 0x20(fp)
  addiu v0, zero, 0x5000
  bne   v1, v0, @@L8040303C
  nop
  lui   v0, 0x1900
  ori   v0, v0, 0x1800
  j     @@L80403468
  sw    v0, (fp)
@@L8040303C:
  lhu   v1, 0x20(fp)
  addiu v0, zero, 0x5001
  bne   v1, v0, @@L8040305C
  nop
  lui   v0, 0x1900
  ori   v0, v0, 0x1850
  j     @@L80403468
  sw    v0, (fp)
@@L8040305C:
  lhu   v1, 0x20(fp)
  addiu v0, zero, 0x5002
  bne   v1, v0, @@L8040307C
  nop
  lui   v0, 0x1900
  ori   v0, v0, 0x18a0
  j     @@L80403468
  sw    v0, (fp)
@@L8040307C:
  lhu   v1, 0x20(fp)
  addiu v0, zero, 0x5003
  bne   v1, v0, @@L8040309C
  nop
  lui   v0, 0x1900
  ori   v0, v0, 0x18f0
  j     @@L80403468
  sw    v0, (fp)
@@L8040309C:
  lhu   v0, 0x20(fp)
  sltiu v0, v0, 0x1602
  bnez  v0, @@L80403194
  nop
  lhu   v0, 0x20(fp)
  sw    v0, 0x14(fp)
  addiu v0, zero, 0x2302
  lw    v1, 0x14(fp)
  beq   v1, v0, @@L80403154
  nop
  lw    v1, 0x14(fp)
  slti  v0, v1, 0x2303
  beqz  v0, @@L804030FC
  nop
  addiu v0, zero, 0x2202
  lw    v1, 0x14(fp)
  beq   v1, v0, @@L80403134
  nop
  addiu v0, zero, 0x2301
  lw    v1, 0x14(fp)
  beq   v1, v0, @@L80403144
  nop
  j     @@L80403468
  nop
@@L804030FC:
  addiu v0, zero, 0x2601
  lw    v1, 0x14(fp)
  beq   v1, v0, @@L80403174
  nop
  addiu v0, zero, 0x3601
  lw    v1, 0x14(fp)
  beq   v1, v0, @@L80403184
  nop
  addiu v0, zero, 0x2401
  lw    v1, 0x14(fp)
  beq   v1, v0, @@L80403164
  nop
  j     @@L80403468
  nop
@@L80403134:
  lui   v0, 0x702
  ori   v0, v0, 0x8780
  j     @@L80403468
  sw    v0, (fp)
@@L80403144:
  lui   v0, 0x700
  ori   v0, v0, 0xfcb4
  j     @@L80403468
  sw    v0, (fp)
@@L80403154:
  lui   v0, 0x700
  ori   v0, v0, 0xfd00
  j     @@L80403468
  sw    v0, (fp)
@@L80403164:
  lui   v0, 0x701
  ori   v0, v0, 0x1e08
  j     @@L80403468
  sw    v0, (fp)
@@L80403174:
  lui   v0, 0x700
  ori   v0, v0, 0x6e6c
  j     @@L80403468
  sw    v0, (fp)
@@L80403184:
  lui   v0, 0x701
  ori   v0, v0, 0x7124
  j     @@L80403468
  sw    v0, (fp)
@@L80403194:
  lhu   v0, 0x20(fp)
  sltiu v0, v0, 0x1103
  bnez  v0, @@L8040328C
  nop
  lhu   v0, 0x20(fp)
  sw    v0, 0x10(fp)
  addiu v0, zero, 0x1205
  lw    v1, 0x10(fp)
  beq   v1, v0, @@L8040324C
  nop
  lw    v1, 0x10(fp)
  slti  v0, v1, 0x1206
  beqz  v0, @@L804031F4
  nop
  addiu v0, zero, 0x1201
  lw    v1, 0x10(fp)
  beq   v1, v0, @@L8040322C
  nop
  addiu v0, zero, 0x1202
  lw    v1, 0x10(fp)
  beq   v1, v0, @@L8040323C
  nop
  j     @@L80403468
  nop
@@L804031F4:
  addiu v0, zero, 0x1302
  lw    v1, 0x10(fp)
  beq   v1, v0, @@L8040326C
  nop
  addiu v0, zero, 0x1601
  lw    v1, 0x10(fp)
  beq   v1, v0, @@L8040327C
  nop
  addiu v0, zero, 0x1301
  lw    v1, 0x10(fp)
  beq   v1, v0, @@L8040325C
  nop
  j     @@L80403468
  nop
@@L8040322C:
  lui   v0, 0x700
  ori   v0, v0, 0xd2cc
  j     @@L80403468
  sw    v0, (fp)
@@L8040323C:
  lui   v0, 0x701
  ori   v0, v0, 0x139c
  j     @@L80403468
  sw    v0, (fp)
@@L8040324C:
  lui   v0, 0x700
  ori   v0, v0, 0xd304
  j     @@L80403468
  sw    v0, (fp)
@@L8040325C:
  lui   v0, 0x701
  ori   v0, v0, 0xe31c
  j     @@L80403468
  sw    v0, (fp)
@@L8040326C:
  lui   v0, 0x701
  ori   v0, v0, 0xe39c
  j     @@L80403468
  sw    v0, (fp)
@@L8040327C:
  lui   v0, 0x701
  ori   v0, v0, 0x1738
  j     @@L80403468
  sw    v0, (fp)
@@L8040328C:
  lhu   v0, 0x20(fp)
  sltiu v0, v0, 0x702
  bnez  v0, @@L80403384
  nop
  lhu   v0, 0x20(fp)
  sw    v0, 0xc(fp)
  addiu v0, zero, 0x851
  lw    v1, 0xc(fp)
  beq   v1, v0, @@L80403344
  nop
  lw    v1, 0xc(fp)
  slti  v0, v1, 0x852
  beqz  v0, @@L804032EC
  nop
  addiu v0, zero, 0x702
  lw    v1, 0xc(fp)
  beq   v1, v0, @@L80403324
  nop
  addiu v0, zero, 0x801
  lw    v1, 0xc(fp)
  beq   v1, v0, @@L80403334
  nop
  j     @@L80403468
  nop
@@L804032EC:
  addiu v0, zero, 0x1101
  lw    v1, 0xc(fp)
  beq   v1, v0, @@L80403364
  nop
  addiu v0, zero, 0x1102
  lw    v1, 0xc(fp)
  beq   v1, v0, @@L80403374
  nop
  addiu v0, zero, 0x1001
  lw    v1, 0xc(fp)
  beq   v1, v0, @@L80403354
  nop
  j     @@L80403468
  nop
@@L80403324:
  lui   v0, 0x702
  ori   v0, v0, 0xb950
  j     @@L80403468
  sw    v0, (fp)
@@L80403334:
  lui   v0, 0x701
  ori   v0, v0, 0x2778
  j     @@L80403468
  sw    v0, (fp)
@@L80403344:
  lui   v0, 0x701
  ori   v0, v0, 0x27c8
  j     @@L80403468
  sw    v0, (fp)
@@L80403354:
  lui   v0, 0x700
  ori   v0, v0, 0xfa70
  j     @@L80403468
  sw    v0, (fp)
@@L80403364:
  lui   v0, 0x701
  ori   v0, v0, 0x8748
  j     @@L80403468
  sw    v0, (fp)
@@L80403374:
  lui   v0, 0x701
  ori   v0, v0, 0x8778
  j     @@L80403468
  sw    v0, (fp)
@@L80403384:
  lhu   v0, 0x20(fp)
  sw    v0, 8(fp)
  addiu v0, zero, 0x501
  lw    v1, 8(fp)
  beq   v1, v0, @@L8040342C
  nop
  lw    v1, 8(fp)
  slti  v0, v1, 0x502
  beqz  v0, @@L804033D4
  nop
  addiu v0, zero, 0x400
  lw    v1, 8(fp)
  beq   v1, v0, @@L8040340C
  nop
  addiu v0, zero, 0x401
  lw    v1, 8(fp)
  beq   v1, v0, @@L8040341C
  nop
  j     @@L80403468
  nop
@@L804033D4:
  addiu v0, zero, 0x612
  lw    v1, 8(fp)
  beq   v1, v0, @@L8040344C
  nop
  addiu v0, zero, 0x701
  lw    v1, 8(fp)
  beq   v1, v0, @@L8040345C
  nop
  addiu v0, zero, 0x600
  lw    v1, 8(fp)
  beq   v1, v0, @@L8040343C
  nop
  j     @@L80403468
  nop
@@L8040340C:
  lui   v0, 0x702
  ori   v0, v0, 0x6e24
  j     @@L80403468
  sw    v0, (fp)
@@L8040341C:
  lui   v0, 0x702
  ori   v0, v0, 0x6e34
  j     @@L80403468
  sw    v0, (fp)
@@L8040342C:
  lui   v0, 0x701
  ori   v0, v0, 0x6708
  j     @@L80403468
  sw    v0, (fp)
@@L8040343C:
  lui   v0, 0x707
  ori   v0, v0, 0x90f0
  j     @@L80403468
  sw    v0, (fp)
@@L8040344C:
  lui   v0, 0x707
  ori   v0, v0, 0x9100
  j     @@L80403468
  sw    v0, (fp)
@@L8040345C:
  lui   v0, 0x702
  ori   v0, v0, 0xb900
  sw    v0, (fp)
@@L80403468:
  lw    v0, (fp)
  move  sp, fp
  lw    fp, 0x1c(sp)
  jr    ra
  addiu sp, sp, 0x20
.dw 0xAAAAAAAA

.org 0x80403500
Func80403500:
  addiu sp, sp, -0x18
  or    a2, a0, zero
  addiu at, zero, 0x702
  beq   at, a2, @@L80403558
  nop
  addiu at, zero, 0x5001
  beq   at, a2, @@L80403558
  nop
  addiu at, zero, 0x851
  beq   at, a2, @@L80403590
  nop
  addiu at, zero, 0x5002
  beq   at, a2, @@L80403590
  nop
  addiu at, zero, 0x1205
  beq   at, a2, @@L804035F8
  nop
  addiu at, zero, 0x5003
  beq   at, a2, @@L80403590
  nop
  b     @@L80403600
  nop
@@L80403558:
  lw    t6, (a1)
  sw    t6, 0x14(sp)
  lw    t7, (a1)
  addiu t8, t7, 8
  sw    t8, (a1)
  lw    t0, 0x14(sp)
  lui   t9, 0x600
  sw    t9, (t0)
  lw    t2, 0x14(sp)
  lui   t1, 0x201
  addiu t1, t1, 0x7630
  sw    t1, 4(t2)
  b     @@L80403638
  nop
@@L80403590:
  lw    t3, (a1)
  sw    t3, 0x10(sp)
  lw    t4, (a1)
  addiu t5, t4, 8
  sw    t5, (a1)
  lw    t7, 0x10(sp)
  lui   t6, 0x600
  sw    t6, (t7)
  lw    t9, 0x10(sp)
  lui   t8, 0x201
  addiu t8, t8, 0x7630
  sw    t8, 4(t9)
  b     @@L80403638
  nop
  lw    t0, (a1)
  sw    t0, 0xc(sp)
  lw    t1, (a1)
  addiu t2, t1, 8
  sw    t2, (a1)
  lw    t4, 0xc(sp)
  lui   t3, 0x600
  sw    t3, (t4)
  lw    t6, 0xc(sp)
  lui   t5, 0x201
  addiu t5, t5, 0x7630
  sw    t5, 4(t6)
@@L804035F8:
  b     @@L80403638
  nop
@@L80403600:
  lw    t7, (a1)
  sw    t7, 8(sp)
  lw    t8, (a1)
  addiu t9, t8, 8
  sw    t9, (a1)
  lw    t1, 8(sp)
  lui   t0, 0x600
  sw    t0, (t1)
  lw    t3, 8(sp)
  lui   t2, 0x201
  addiu t2, t2, 0x75f0
  sw    t2, 4(t3)
  b     @@L80403638
  nop
@@L80403638:
  b     @@L80403640
  nop
@@L80403640:
  jr    ra
  addiu sp, sp, 0x18

.close

